--- libvirt-0.6.1.org/src/storage_driver.c	2009-05-20 14:08:22.847298000 +0200
+++ libvirt-0.6.1/src/storage_driver.c	2009-05-29 16:28:42.335706000 +0200
@@ -498,11 +498,13 @@
     pool->active = 1;
 
     ret = virGetStoragePool(conn, pool->def->name, pool->def->uuid);
+    virStoragePoolObjUnlock(pool);
+    pool = NULL;
 
 cleanup:
     virStoragePoolDefFree(def);
     if (pool)
-        virStoragePoolObjUnlock(pool);
+        virStoragePoolObjRemove(&driver->pools, pool);
     storageDriverUnlock(driver);
     return ret;
 }
